curl --request GET \
--url https://api.recursion.labelbox.com/managed-agents/v1/sessions/{session_id}/tree \
--header 'Authorization: Bearer <token>'import requests
url = "https://api.recursion.labelbox.com/managed-agents/v1/sessions/{session_id}/tree"
headers = {"Authorization": "Bearer <token>"}
response = requests.get(url, headers=headers)
print(response.text)const options = {method: 'GET', headers: {Authorization: 'Bearer <token>'}};
fetch('https://api.recursion.labelbox.com/managed-agents/v1/sessions/{session_id}/tree', options)
.then(res => res.json())
.then(res => console.log(res))
.catch(err => console.error(err));
{
"events": [
{
"actor": "human:api",
"agent_id": "9f8b1c2d-3e4f-5a6b-7c8d-9e0f1a2b3c4d",
"cache_read_tokens": 1,
"cache_write_tokens": 1,
"causal_event_id": "9f8b1c2d-3e4f-5a6b-7c8d-9e0f1a2b3c4d",
"content": {
"blocks": [
{
"byte_size": 1,
"content": [],
"context": "example",
"data": "example",
"encrypted_content": "example",
"height": 1,
"id": "9f8b1c2d-3e4f-5a6b-7c8d-9e0f1a2b3c4d",
"input": {
"key": "example"
},
"is_error": true,
"media_type": "example",
"name": "example-name",
"omitted_bytes": 1,
"payload": "example",
"provider": "example",
"provider_payload": "example",
"redacted": true,
"semantic_hint": "example",
"sha256": "example",
"signature": "example",
"source": {
"file_id": "9f8b1c2d-3e4f-5a6b-7c8d-9e0f1a2b3c4d",
"type": "file"
},
"summary": [],
"text": "example",
"title": "example",
"tool_use_id": "9f8b1c2d-3e4f-5a6b-7c8d-9e0f1a2b3c4d",
"type": "example",
"uri": "example",
"url": "https://example.com",
"url_expires_at": "2026-02-18T09:30:00.000Z",
"width": 1
}
],
"evaluation_budget_reached": {
"affected_target_session_ids": [
"9f8b1c2d-3e4f-5a6b-7c8d-9e0f1a2b3c4d"
],
"max_tree_cost_usd": "example"
},
"evaluation_plan_frozen": {
"criteria": [
{
"criterion_key": "example",
"criterion_text": "example"
}
],
"max_concurrent_threads": 1,
"max_tree_cost_usd": "example",
"targets": [
{
"snapshot_event_id": "9f8b1c2d-3e4f-5a6b-7c8d-9e0f1a2b3c4d",
"target_session_id": "9f8b1c2d-3e4f-5a6b-7c8d-9e0f1a2b3c4d"
}
]
},
"evaluation_run_finished": {
"failure_code": "plan_failed",
"failure_message": "example",
"targets_budget_reached": 1,
"targets_skipped": 1,
"targets_total": 1,
"terminal_status": "completed",
"verdicts_recorded": 1
},
"evaluation_target_skipped": {
"child_session_id": "9f8b1c2d-3e4f-5a6b-7c8d-9e0f1a2b3c4d",
"reason": "example",
"reason_code": "child_create_failed",
"snapshot_event_id": "9f8b1c2d-3e4f-5a6b-7c8d-9e0f1a2b3c4d",
"target_session_id": "9f8b1c2d-3e4f-5a6b-7c8d-9e0f1a2b3c4d"
},
"evaluation_target_started": {
"child_session_id": "9f8b1c2d-3e4f-5a6b-7c8d-9e0f1a2b3c4d",
"clone_state": "ready",
"evaluation_id": "9f8b1c2d-3e4f-5a6b-7c8d-9e0f1a2b3c4d",
"sandbox_provider": "example",
"snapshot_event_id": "9f8b1c2d-3e4f-5a6b-7c8d-9e0f1a2b3c4d",
"target_session_id": "9f8b1c2d-3e4f-5a6b-7c8d-9e0f1a2b3c4d"
},
"evaluation_verdict_recorded": {
"child_session_id": "9f8b1c2d-3e4f-5a6b-7c8d-9e0f1a2b3c4d",
"cost_completeness": "complete",
"cost_usd": "example",
"evaluation_id": "9f8b1c2d-3e4f-5a6b-7c8d-9e0f1a2b3c4d",
"failed_criterion_keys": [
"example"
],
"result": "pass",
"snapshot_event_id": "9f8b1c2d-3e4f-5a6b-7c8d-9e0f1a2b3c4d",
"target_session_id": "9f8b1c2d-3e4f-5a6b-7c8d-9e0f1a2b3c4d"
},
"metadata": {
"key": "example"
},
"plan": [
{
"content": "example",
"id": "9f8b1c2d-3e4f-5a6b-7c8d-9e0f1a2b3c4d",
"status": "example"
}
],
"stop_reason": "example",
"tools": [
{
"description": "example",
"input_schema": {
"key": "example"
},
"name": "example-name"
}
],
"usage": {
"cache_read_tokens": 1,
"cache_write_tokens": 1,
"cost_usd": 1.5,
"input_tokens": 1,
"output_tokens": 1
}
},
"content_hydration_status": "hydrated",
"content_payload_bytes": 1,
"content_payload_ref": "example",
"content_payload_sha256": "example",
"content_ref": "example",
"cost_micros": 1,
"created_at": "2026-02-18T09:30:00.000Z",
"environment_id": "9f8b1c2d-3e4f-5a6b-7c8d-9e0f1a2b3c4d",
"event_id": "9f8b1c2d-3e4f-5a6b-7c8d-9e0f1a2b3c4d",
"event_status": "example",
"event_type": "example",
"finish_reason": "example",
"inference_config": {
"max_tokens": 1,
"provider_params": {
"key": "example"
},
"reasoning_effort": "example",
"temperature": 1.5,
"top_p": 1.5
},
"input_tokens": 1,
"latency_ms": 1,
"model": {
"base_url": "https://example.com",
"capabilities": {
"key": "example"
},
"context_window": 1,
"max_output_tokens": 1,
"metadata": {
"key": "example"
},
"model": "example",
"model_ref_id": "9f8b1c2d-3e4f-5a6b-7c8d-9e0f1a2b3c4d",
"model_version": "example",
"provider": "example",
"provider_id": "9f8b1c2d-3e4f-5a6b-7c8d-9e0f1a2b3c4d",
"provider_type": "example",
"serving_backend": "example"
},
"model_ref_id": "9f8b1c2d-3e4f-5a6b-7c8d-9e0f1a2b3c4d",
"organization_id": "9f8b1c2d-3e4f-5a6b-7c8d-9e0f1a2b3c4d",
"output_tokens": 1,
"parent_event_id": "9f8b1c2d-3e4f-5a6b-7c8d-9e0f1a2b3c4d",
"prompt_tokens": 1,
"provider_model_id": "9f8b1c2d-3e4f-5a6b-7c8d-9e0f1a2b3c4d",
"provider_request_id": "9f8b1c2d-3e4f-5a6b-7c8d-9e0f1a2b3c4d",
"provider_type": "example",
"role": "user",
"sandbox_instance_id": "9f8b1c2d-3e4f-5a6b-7c8d-9e0f1a2b3c4d",
"schema_version": 1,
"session_id": "9f8b1c2d-3e4f-5a6b-7c8d-9e0f1a2b3c4d",
"thread_id": "9f8b1c2d-3e4f-5a6b-7c8d-9e0f1a2b3c4d",
"tool_name": "example",
"tool_use_id": "9f8b1c2d-3e4f-5a6b-7c8d-9e0f1a2b3c4d",
"turn_id": "9f8b1c2d-3e4f-5a6b-7c8d-9e0f1a2b3c4d"
}
],
"next_event_id": "9f8b1c2d-3e4f-5a6b-7c8d-9e0f1a2b3c4d",
"root_session_id": "9f8b1c2d-3e4f-5a6b-7c8d-9e0f1a2b3c4d",
"sessions": [
{
"access_policy": "admin_only",
"active_handoff": {
"access_expires_at": "2026-02-18T09:30:00.000Z",
"deadline_at": "2026-02-18T09:30:00.000Z",
"handoff_id": "9f8b1c2d-3e4f-5a6b-7c8d-9e0f1a2b3c4d",
"reason": "example",
"requested_at": "2026-02-18T09:30:00.000Z",
"state": "awaiting_user",
"wake_cause": "example"
},
"agent_id": "9f8b1c2d-3e4f-5a6b-7c8d-9e0f1a2b3c4d",
"agent_snapshot": {
"key": "example"
},
"agent_version_id": "9f8b1c2d-3e4f-5a6b-7c8d-9e0f1a2b3c4d",
"computer_use": true,
"concurrency_slot_held": true,
"config": {
"key": "example"
},
"created_at": "2026-02-18T09:30:00.000Z",
"credential_refs": [
{
"credential_id": "9f8b1c2d-3e4f-5a6b-7c8d-9e0f1a2b3c4d",
"vault_id": "9f8b1c2d-3e4f-5a6b-7c8d-9e0f1a2b3c4d"
}
],
"credential_refs_configured": true,
"effective_model": "example",
"environment_id": "9f8b1c2d-3e4f-5a6b-7c8d-9e0f1a2b3c4d",
"execution_state": "provisioning",
"external_source_id": "9f8b1c2d-3e4f-5a6b-7c8d-9e0f1a2b3c4d",
"external_source_type": "example",
"failure": {
"at": "2026-02-18T09:30:00.000Z",
"category": "transient",
"code": "example",
"message": "example",
"phase": "example",
"retryable": true
},
"forked_at_event_id": "9f8b1c2d-3e4f-5a6b-7c8d-9e0f1a2b3c4d",
"kind": "api_call",
"last_activity_at": "2026-02-18T09:30:00.000Z",
"metadata": {
"key": "example"
},
"model_ref_id": "9f8b1c2d-3e4f-5a6b-7c8d-9e0f1a2b3c4d",
"model_snapshot": {
"key": "example"
},
"organization_id": "9f8b1c2d-3e4f-5a6b-7c8d-9e0f1a2b3c4d",
"parent_session_id": "9f8b1c2d-3e4f-5a6b-7c8d-9e0f1a2b3c4d",
"root_session_id": "9f8b1c2d-3e4f-5a6b-7c8d-9e0f1a2b3c4d",
"sandbox_instance_id": "9f8b1c2d-3e4f-5a6b-7c8d-9e0f1a2b3c4d",
"sandbox_provider": "example",
"session_id": "9f8b1c2d-3e4f-5a6b-7c8d-9e0f1a2b3c4d",
"session_path": "example",
"source_refs": {
"key": "example"
},
"status": "active",
"stop_reason": "example",
"tenant_id": "9f8b1c2d-3e4f-5a6b-7c8d-9e0f1a2b3c4d",
"updated_at": "2026-02-18T09:30:00.000Z",
"user_id": "9f8b1c2d-3e4f-5a6b-7c8d-9e0f1a2b3c4d",
"vault_ids": [
"example"
],
"wake_at": "2026-02-18T09:30:00.000Z"
}
],
"threads": [
{
"agent_id": "9f8b1c2d-3e4f-5a6b-7c8d-9e0f1a2b3c4d",
"agent_version_id": "9f8b1c2d-3e4f-5a6b-7c8d-9e0f1a2b3c4d",
"archived_at": "2026-02-18T09:30:00.000Z",
"created_at": "2026-02-18T09:30:00.000Z",
"name": "example-name",
"parent_session_id": "9f8b1c2d-3e4f-5a6b-7c8d-9e0f1a2b3c4d",
"parent_thread_id": "9f8b1c2d-3e4f-5a6b-7c8d-9e0f1a2b3c4d",
"role": "user",
"root_session_id": "9f8b1c2d-3e4f-5a6b-7c8d-9e0f1a2b3c4d",
"session_id": "9f8b1c2d-3e4f-5a6b-7c8d-9e0f1a2b3c4d",
"session_path": "example",
"status": "example",
"stop_reason": {
"key": "example"
},
"thread_id": "9f8b1c2d-3e4f-5a6b-7c8d-9e0f1a2b3c4d",
"thread_path": "example",
"updated_at": "2026-02-18T09:30:00.000Z"
}
]
}{
"code": "invalid_request",
"message": "<string>",
"details": {
"field": "<string>",
"issues": [
"<string>"
],
"requestId": "<string>",
"retryable": true
}
}{
"code": "unauthorized",
"message": "<string>",
"details": {
"field": "<string>",
"issues": [
"<string>"
],
"requestId": "<string>",
"retryable": true
}
}{
"code": "forbidden",
"message": "<string>",
"details": {
"field": "<string>",
"issues": [
"<string>"
],
"requestId": "<string>",
"retryable": true
}
}{
"code": "not_found",
"message": "<string>",
"details": {
"field": "<string>",
"issues": [
"<string>"
],
"requestId": "<string>",
"retryable": true
}
}{
"code": "rate_limit_exceeded",
"message": "<string>",
"details": {
"field": "<string>",
"issues": [
"<string>"
],
"requestId": "<string>",
"retryable": true
}
}{
"code": "internal_error",
"message": "<string>",
"details": {
"field": "<string>",
"issues": [
"<string>"
],
"requestId": "<string>",
"retryable": true
}
}{
"code": "bad_gateway",
"message": "<string>",
"details": {
"field": "<string>",
"issues": [
"<string>"
],
"requestId": "<string>",
"retryable": true
}
}{
"code": "content_store_unavailable",
"message": "<string>",
"details": {
"field": "<string>",
"issues": [
"<string>"
],
"requestId": "<string>",
"retryable": true
}
}{
"code": "gateway_timeout",
"message": "<string>",
"details": {
"field": "<string>",
"issues": [
"<string>"
],
"requestId": "<string>",
"retryable": true
}
}Get root session tree and timeline
Returns every session in the root session’s tree, its threads, and the first bounded page of the merged chronological event log. When next_event_id is set, more events remain and should be fetched with listSessionEvents rather than by re-reading the tree. Any session id in the tree is accepted; the read resolves to its root.
Authorizations
A Recursion API key, created in the console under API keys.
Path Parameters
Any session id (UUID) in the tree; the read resolves to its root session.
Query Parameters
Opt-in compatibility mode. images rehydrates private image refs under strict response caps; omitted by default.
images Set to signed to add a short-lived url (and url_expires_at) to stored image blocks within the per-read signing budget. Omitted when signing is unavailable or the budget is exhausted; the authenticated getSessionImage endpoint always works.
signed External event payloads hydrate by default. Set refs to return bounded stubs and private reference metadata only.
refs Response
A whole multi-agent session tree: every session and thread in it, plus a bounded page of the merged chronological event log. Returned when reading the tree containing a given session.
A whole multi-agent session tree: every session and thread in it, plus a bounded page of the merged chronological event log. Returned when reading the tree containing a given session.
One page of the tree's events merged into a single chronological log across all sessions. Bounded by response size, so the page length is not a fixed count.
Show child attributes
Show child attributes
Root session of the multi-agent tree this result covers (UUID). Equal to session_id for a root session.
Every session in the tree, root and subagents alike. Always complete; only the event log is paged.
Show child attributes
Show child attributes
Thread registry rows for the tree's context-isolated execution streams. Imported RL children appear when their import supplied thread names; older imports without names use session-derived fallback rows.
Show child attributes
Show child attributes
Cursor to pass as the starting point of the next event page. Present only when more events remain; absent on the last page.